/*
 * demo.c - Demonstration der Funktionsweise der neuen Funktion
 *          XmAppMainLoop(), die die bisherige Xt-Variante vom MIT
 *          ersetzt.
 * Letzte Modifikation: 1.8.1994
 * (c) Harald Albrecht ( albrecht@igpm.rwth-aachen.de )
 */

#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/MainW.h>
#include <Xm/RowColumn.h>
#include <Xm/Frame.h>
#include <Xm/CascadeB.h>
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>
#include <X11/keysym.h>
#include <stdio.h>

#include "mnemonic.h" /* !!! */

void DummyCallback(Widget w, XtPointer clientdata, XtPointer calldata)
{
    KeySym KSym;
    fprintf(stderr, "%s\n", XtName(w));
    XtVaGetValues(w, XmNmnemonic, &KSym, NULL);
    if ( KSym == XK_x ) exit(0);
} /* DummyCallback */

int main(Cardinal argc, char **argv)
{
    XtAppContext AppCtx;
    Widget       TopLevel, Main, Menu, Form, Text, PullDownMenu;
    Widget       Cascade, Butt1, Butt2, Butt3, Butt4, Butt5;
    Widget       Frame, Label, RowCol;
    XmString     str1, str2, str3;
    Arg          args[10];
    
    TopLevel = XtVaAppInitialize(&AppCtx, "Demo", NULL, 0, 
                                 &argc, argv, NULL, NULL);
    Main = XmCreateMainWindow(TopLevel, "main", NULL, 0);
    XtManageChild(Main);
    Menu = XmCreateMenuBar(Main, "menu", NULL, 0);
    XtManageChild(Menu);
    XtSetArg(args[0], XmNmnemonic, XK_F);
    Cascade = XmCreateCascadeButton(Menu, "File", args, 1);
    XtManageChild(Cascade);
    str1 = XmStringCreateSimple("Exit");
    str2 = XmStringCreateSimple("Ignore");
    str3 = XmStringCreateSimple("Not to mention...");
    PullDownMenu = XmVaCreateSimplePulldownMenu(Menu, "datei", 0, 
        (XtCallbackProc) DummyCallback, 
	XmVaPUSHBUTTON, str2, XK_I, NULL, NULL, 
	XmVaPUSHBUTTON, str3, XK_N, NULL, NULL, 
	XmVaSEPARATOR, 
	XmVaPUSHBUTTON, str1, XK_x, NULL, NULL, 
	NULL);
    XmStringFree(str1); XmStringFree(str2); XmStringFree(str3);
    Form = XtVaCreateManagedWidget("form", xmFormWidgetClass, Main, NULL);
    Butt1 = XtVaCreateManagedWidget(
	"I'm a button",  xmPushButtonWidgetClass, Form, 
	XmNleftAttachment,  XmATTACH_FORM, 
	XmNleftOffset,      20, 
	XmNtopAttachment,   XmATTACH_FORM, 
	XmNtopOffset,       8, 
	XmNmnemonic,	    XK_b, 
	NULL);
    Butt2 = XtVaCreateManagedWidget(
	"click on me...", xmPushButtonWidgetClass, Form, 
	XmNleftAttachment,  XmATTACH_WIDGET, 
	XmNleftWidget,      Butt1, 
	XmNleftOffset,      5, 
	XmNtopAttachment,   XmATTACH_FORM, 
	XmNtopOffset,       8, 
	XmNrightAttachment, XmATTACH_FORM, 
	XmNrightOffset,     5, 
	XmNmnemonic,	    XK_c, 
	NULL);
    Label = XtVaCreateManagedWidget(
        "switches", xmLabelWidgetClass, Form, 
	XmNleftAttachment,  XmATTACH_FORM, 
	XmNleftOffset,      24,
	XmNtopAttachment,   XmATTACH_WIDGET, 
	XmNtopWidget,       Butt1, 
	XmNtopOffset,       8, 
	XmNmnemonic,        XK_s, 
	NULL);
    Frame = XtVaCreateManagedWidget(
        "Rahmen", xmFrameWidgetClass, Form, 
	XmNleftAttachment,  XmATTACH_FORM, 
	XmNleftOffset,      20, 
	XmNtopAttachment,   XmATTACH_WIDGET, 
	XmNtopWidget,       Label, 
	XmNrightAttachment, XmATTACH_FORM, 
	XmNrightOffset,     20,  
	NULL);
    RowCol = XtVaCreateManagedWidget(
	"RowCol", xmRowColumnWidgetClass, Frame, 
        NULL);
    Butt3 = XtVaCreateManagedWidget(
	"not toggleable", xmToggleButtonWidgetClass, RowCol,
	XmNmnemonic,        XK_n, 
	XmNsensitive, False, 
	NULL);
    Butt4 = XtVaCreateManagedWidget(
	"toggle me", xmToggleButtonWidgetClass, RowCol,
	XmNmnemonic,        XK_t, 
	NULL);
    Butt5 = XtVaCreateManagedWidget(
	"me too!", xmToggleButtonWidgetClass, RowCol,
	XmNmnemonic,        XK_m, 
	NULL);
    Text = XtVaCreateManagedWidget(
	"Example of the new XmAppMainLoop()", 
	xmLabelWidgetClass, Form, 
	XmNleftAttachment,   XmATTACH_FORM, 
	XmNleftOffset,	     20, 
	XmNrightAttachment,  XmATTACH_FORM, 
	XmNrightOffset,	     20, 
	XmNtopAttachment,    XmATTACH_WIDGET, 
	XmNtopWidget,        Frame, 
	XmNtopOffset,        20, 
	XmNbottomAttachment, XmATTACH_FORM, 
	XmNbottomOffset,     20, 
	NULL);
    XmMainWindowSetAreas(Main, Menu, NULL, NULL, NULL, Form);
    XtRealizeWidget(TopLevel);
    XmAppMainLoop(AppCtx); /* !!! */
    return 0;   
} /* main */
